<script setup lang="ts">
    import SInterventionForm from '@/interventionServiceOffer/components/intervention/SInterventionForm.vue'
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import { InterventionApi } from '@/interventionServiceOffer/entities/intervention/InterventionApi'
    import { InterventionPriority } from '@/interventionServiceOffer/entities/intervention/InterventionDto'
    import { interventionMapper } from '@/interventionServiceOffer/entities/intervention/InterventionMapper'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import SImageCollectionEditor from '@/shared/document/components/SImageCollectionEditor.vue'
    import { deepEquals } from '@/shared/helpers/objects'
    import { requiredInject } from '@/shared/helpers/types'
    import {
        ComputedRef,
        computed,
        readonly,
        ref,
        toValue,
        watchEffect,
    } from 'vue'

    interface Props {
        availableEquipements: Equipement[]
        isLoadingAvailableEquipements: boolean
        interventionOriginale?: Partial<Intervention>
        hiddenFields?: { [Property in keyof Intervention]?: true }
    }

    const props = withDefaults(defineProps<Props>(), {
        interventionOriginale: () => ({}),
        hiddenFields: undefined,
    })

    const valeuresParDefaut = computed<Partial<Intervention>>(() => ({
        relatedEquipement:
            props.availableEquipements.length === 1
                ? props.availableEquipements[0]
                : undefined,
        priority: InterventionPriority.Normal,
        dateDeDebut:
            Intervention.getDateParDefautPourCreationNouvelleIntervention()
                .dateDeDebut,
        dateDeFin:
            Intervention.getDateParDefautPourCreationNouvelleIntervention()
                .dateDeFin,
    }))

    const intervention = ref<Partial<Intervention>>(
        mergeValeurParDefautEtInterventionsOrginale()
    )

    watchEffect(() => {
        intervention.value = mergeValeurParDefautEtInterventionsOrginale()
    })

    function mergeValeurParDefautEtInterventionsOrginale() {
        return {
            ...valeuresParDefaut.value,
            ...toValue(props.interventionOriginale),
        }
    }

    const interventionFormRef = ref<InstanceType<
        typeof SInterventionForm
    > | null>(null)
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )
    const formFieldsAreValid: ComputedRef<boolean> = computed(() => {
        return !!interventionFormRef.value?.formFieldsAreValid
    })
    const msal = useMsal()

    const interventionApi = new InterventionApi(msal)

    const addedImagesAvantB64 = ref<string[]>([])
    const addedImagesAprèsB64 = ref<string[]>([])

    const isProcessing = ref<boolean>(false)
    const isDirty = computed(() => {
        return !deepEquals(
            {
                ...intervention.value,
                // Si le titre automatique est activé, ça ne doit pas entrer dans les modifications à prendre en compte
                title: interventionFormRef.value?.autoTitleEnabled
                    ? undefined
                    : intervention.value.title,
            },
            {
                ...mergeValeurParDefautEtInterventionsOrginale(),
                title: interventionFormRef.value?.autoTitleEnabled
                    ? undefined
                    : mergeValeurParDefautEtInterventionsOrginale().title,
            }
        )
    })

    async function créerIntervention() {
        try {
            isProcessing.value = true

            const createdIntervention = await interventionApi.create(
                serviceOfferId.value,
                interventionMapper.toCreateDto(intervention.value)
            )
            createdIntervention.imagesAvant = await interventionApi.addImages(
                serviceOfferId.value,
                createdIntervention.id,
                addedImagesAvantB64.value,
                'images-avant'
            )
            createdIntervention.imagesApres = await interventionApi.addImages(
                serviceOfferId.value,
                createdIntervention.id,
                addedImagesAprèsB64.value,
                'images-apres'
            )

            getAnalyticsProvider().sendEvent(
                serviceOfferTrackingCategory.value,
                "Création d'intervention",
                `${createdIntervention.code} : ${createdIntervention.title}`
            )

            return createdIntervention
        } finally {
            isProcessing.value = false
        }
    }
    defineExpose({
        créerIntervention,
        formFieldsAreValid: readonly(formFieldsAreValid),
        isProcessing: readonly(isProcessing),
        isDirty: readonly(isDirty),
    })
</script>

<template>
    <div>
        <v-row>
            <v-col
                v-if="!hiddenFields?.imagesAvant"
                data-cy="photos-avant"
                cols="12"
            >
                <h6 class="text-h6">Photos avant l'intervention</h6>
                <s-image-collection-editor
                    v-model:added-images-b64="addedImagesAvantB64"
            /></v-col>
            <v-col
                v-if="!hiddenFields?.imagesApres"
                data-cy="photos-après"
                cols="12"
            >
                <h6 class="text-h6">Photos après l'intervention</h6>
                <s-image-collection-editor
                    v-model:added-images-b64="addedImagesAprèsB64"
            /></v-col>
        </v-row>
        <s-intervention-form
            ref="interventionFormRef"
            v-model="intervention"
            :hidden-fields="hiddenFields"
            :available-equipements="availableEquipements"
            :is-loading-available-equipements="isLoadingAvailableEquipements"
        >
        </s-intervention-form>
    </div>
</template>
